
package de.bsvrz.sys.startstopp.api.jsonschema;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;
import com.fasterxml.jackson.annotation.JsonAnyGetter;
import com.fasterxml.jackson.annotation.JsonAnySetter;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;

@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonPropertyOrder({
    "inkarnationsName"
})
public class KernSystem implements Serializable
{

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("inkarnationsName")
    private String inkarnationsName;
    @JsonIgnore
    private Map<String, Object> additionalProperties = new HashMap<String, Object>();
    private final static long serialVersionUID = 5508859599797416064L;

    /**
     * No args constructor for use in serialization
     * 
     */
    public KernSystem() {
    }

    /**
     * 
     * @param inkarnationsName
     */
    public KernSystem(String inkarnationsName) {
        super();
        this.inkarnationsName = inkarnationsName;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("inkarnationsName")
    public String getInkarnationsName() {
        return inkarnationsName;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("inkarnationsName")
    public void setInkarnationsName(String inkarnationsName) {
        this.inkarnationsName = inkarnationsName;
    }

    public KernSystem withInkarnationsName(String inkarnationsName) {
        this.inkarnationsName = inkarnationsName;
        return this;
    }

    @JsonAnyGetter
    public Map<String, Object> getAdditionalProperties() {
        return this.additionalProperties;
    }

    @JsonAnySetter
    public void setAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
    }

    public KernSystem withAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
        return this;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(KernSystem.class.getName()).append('@').append(Integer.toHexString(System.identityHashCode(this))).append('[');
        sb.append("inkarnationsName");
        sb.append('=');
        sb.append(((this.inkarnationsName == null)?"<null>":this.inkarnationsName));
        sb.append(',');
        sb.append("additionalProperties");
        sb.append('=');
        sb.append(((this.additionalProperties == null)?"<null>":this.additionalProperties));
        sb.append(',');
        if (sb.charAt((sb.length()- 1)) == ',') {
            sb.setCharAt((sb.length()- 1), ']');
        } else {
            sb.append(']');
        }
        return sb.toString();
    }

    @Override
    public int hashCode() {
        int result = 1;
        result = ((result* 31)+((this.inkarnationsName == null)? 0 :this.inkarnationsName.hashCode()));
        result = ((result* 31)+((this.additionalProperties == null)? 0 :this.additionalProperties.hashCode()));
        return result;
    }

    @Override
    public boolean equals(Object other) {
        if (other == this) {
            return true;
        }
        if ((other instanceof KernSystem) == false) {
            return false;
        }
        KernSystem rhs = ((KernSystem) other);
        return (((this.inkarnationsName == rhs.inkarnationsName)||((this.inkarnationsName!= null)&&this.inkarnationsName.equals(rhs.inkarnationsName)))&&((this.additionalProperties == rhs.additionalProperties)||((this.additionalProperties!= null)&&this.additionalProperties.equals(rhs.additionalProperties))));
    }

}
